from typing import List, Union
from .输出 import 输出函数
import types
当前域 = []


def 进入域(域):
    当前域.append(域)


def 退出域():
    当前域.pop(-1)


def 输出(内容: str, 输出前缀: bool = True):
    if 输出前缀:
        for i in range(len(当前域)):
            输出函数('    ')
    输出函数(内容)


class 花括号:
    def __enter__(self, *args, **kwargs):
        输出("{\n")
        进入域(self)

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("}\n")


class c函数域:
    def __init__(
            self,
            函数名: str,
            参数名及类型,
            返回类型,
            前缀: Union[None, str, List[str]] = None) -> None:
        self.函数名 = 函数名
        self.参数名及类型 = 参数名及类型
        try:
            self.返回类型 = getattr(返回类型, '类型名')
        except:
            self.返回类型 = None
        if isinstance(前缀, str):
            self.前缀 = 前缀
        elif isinstance(前缀, list):
            self.前缀 = ' '.join(前缀)
        else:
            self.前缀 = ''

    def __enter__(self, *args, **kwargs):
        输出(self.前缀)
        输出(' ')
        if self.返回类型 is None:
            输出('void ')
        else:
            输出(self.返回类型)
        输出(' ', False)
        输出(self.函数名, False)
        输出('(', False)
        参数数量 = len(self.参数名及类型.keys())
        i = 0
        for k, v in self.参数名及类型.items():
            if k == 'self':
                i += 1
                continue
            输出(f'{v.annotation.类型名} {k}', False)
            if i < 参数数量 - 1:
                输出(', ', False)
            i += 1
        输出(')', False)
        输出("{\n", False)
        进入域(self)
        return self

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("}\n")

    def 返回(self, 返回值):
        输出(f'return {str(返回值)};\n')


class c_结构体域:
    def __init__(self, 类型名: str) -> None:
        self.类型名 = 类型名

    def __enter__(self, *args, **kwargs):
        输出(f"struct {self.类型名}")
        输出("{\n")
        进入域(self)

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("};\n")


class 如果:
    def __init__(self, 条件) -> types.NoneType:
        self.条件 = 条件

    def __enter__(self, *args, **kwargs):
        输出(f"if ({self.条件}){{\n")
        进入域(self)

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("}\n")


class 否则:
    def __enter__(self, *args, **kwargs):
        输出("else {\n")
        进入域(self)

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("}\n")


class 否则如果:
    def __init__(self, 条件) -> types.NoneType:
        self.条件 = 条件

    def __enter__(self, *args, **kwargs):
        输出(f"else if ({self.条件}){{\n")
        进入域(self)

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("}\n")


class 循环:
    def __init__(self, 条件) -> types.NoneType:
        self.条件 = 条件

    def __enter__(self, *args, **kwargs):
        输出(f"while ({self.条件}){{\n")
        进入域(self)
        return self

    def __exit__(self, *args, **kwargs):
        退出域()
        输出("}\n")

    def 继续(self):
        输出("continue;\n")

    def 跳出(self):
        输出("break;\n")
