from .utils import 十进制转换为其他进制
from typing import Union, Any, Callable, Type, List
from .c域 import 输出, c函数域, c_结构体域
import inspect


class c类型基础:
    _进制字符 = "0123456789abcdefghigklmnopqrstuvwxyzABCDEFGHIGKLMNOPQRSTUVWXYZ"
    变量自增ID = 0
    类型名 = ''
    是结构体类 = False

    @staticmethod
    def 生成ID():
        ID = '_' + 十进制转换为其他进制(c类型基础.变量自增ID, len(c类型基础._进制字符), c类型基础._进制字符)
        c类型基础.变量自增ID += 1
        return ID

    def __init__(
            self,
            初始值: Union[Any, None] = '',
            变量名: Union[str, None] = None,
            是静态变量: Union[bool, None] = False,
            使用等号赋值: bool = False):
        self.类型 = self.__class__.类型名
        self.变量名 = 变量名 or c类型基础.生成ID()
        self.是静态变量 = 是静态变量  # TODO
        self.使用等号赋值 = 使用等号赋值
        self.初始值 = 初始值
        self.生成初始值字符串()
        self.输出定义()

    def 类型名称(self):
        return f'{self.类型}'

    def 生成初始值字符串(self):
        self.初始化字符串 = f'({self.初始值})'
        if self.使用等号赋值:
            self.初始化字符串 = f'= {self.初始化字符串}'
        if isinstance(self.初始值, str) and len(self.初始值) == 0:
            self.初始化字符串 = ''

    def 输出定义(self):
        输出(f'{self.类型名称()} {self.变量名} {self.初始化字符串};\n')

    def 赋值为(self, new_value):
        输出(f'{self.变量名} = ({new_value});\n')

    def 获取成员值(self, 字段名: str):
        if self.__class__.类型名.strip().endswith('*'):
            return f'{self.变量名}->{字段名}'
        else:
            return f'{self.变量名}.{字段名}'

    def 成员赋值(self, 字段名: str, 数值):
        if self.__class__.类型名.strip().endswith('*'):
            输出(f'{self.变量名}->{字段名} = {数值};\n')
        else:
            输出(f'{self.变量名}.{字段名} = {数值};\n')

    def __str__(self) -> str:
        return self.变量名

    def 取址(self):
        return f'(&{self.变量名})'

    def 析址(self):
        return f'(*{self.变量名})'

    def __add__(self, other):
        return f'{self} + {other}'

    def __sub__(self, other):
        return f'{self} - {other}'

    def __mul__(self, other):
        return f'{self} * {other}'

    def __truediv__(self, other):
        return f'{self} / {other}'

    def __mod__(self, other):
        return f'{self} % {other}'

    def __lshift__(self, other):
        return f'{self} << {other}'

    def __rshift__(self, other):
        return f'{self} >> {other}'

    def __and__(self, other):
        return f'{self} & {other}'

    def __or__(self, other):
        return f'{self} | {other}'

    def __xor__(self, other):
        return f'{self} ^ {other}'

    def __iadd__(self, other):
        输出(f'{self} += {other};\n')
        return self

    def __isub__(self, other):
        输出(f'{self} -= {other}\n')
        return self

    def __imul__(self, other):
        输出(f'{self} *= {other}\n')
        return self

    def __itruediv__(self, other):
        输出(f'{self} /= {other}\n')
        return self

    def __imod__(self, other):
        输出(f'{self} %= {other}\n')
        return self

    def __ilshift__(self, other):
        输出(f'{self} <<= {other}\n')
        return self

    def __irshift__(self, other):
        输出(f'{self} >>= {other}\n')
        return self

    def __iand__(self, other):
        输出(f'{self} &= {other}\n')
        return self

    def __ior__(self, other):
        输出(f'{self} |= {other}\n')
        return self

    def __ixor__(self, other):
        输出(f'{self} ^= {other}\n')
        return self

    def __invert__(self):
        return f'~{self}'

    def __getitem__(self, key):
        return f'{self}[{key}]'

    def __setitem__(self, key, value):
        输出(f'{self}[{key}] = {value};\n')

    def __call__(self, *args: Any) -> Any:
        if self.__class__.是结构体类:
            if len(args) == 0:
                return self.赋值为
            if len(args) == 1:
                return self.获取成员值(args[0])
            if len(args) == 2:
                self.成员赋值(args[0], args[1])
            return self

        self.赋值为(args[0])

    def 等于(self, other):
        return f'{self} == {other}'

    def 不等于(self, other):
        return f'{self} != {other}'

    def 大于(self, other):
        return f'{self} > {other}'

    def 小于(self, other):
        return f'{self} < {other}'

    def 大于等于(self, other):
        return f'{self} >= {other}'

    def 小于等于(self, other):
        return f'{self} <= {other}'

    def 强转(self, 类型):
        return f'(({类型.类型名}){self})'


def 创建普通类(类型: str) -> Type:
    class 类(c类型基础):
        类型名 = 类型
    return 类


class c_void(c类型基础):
    类型名 = 'void'

    def __init__(self):
        self.类型 = self.__class__.类型名
        self.变量名 = ''

    def 输出定义(self):
        pass

    def 赋值为(self, new_value):
        pass


class c_void_p(c类型基础):
    类型名 = 'void*'


class 已存在变量(c类型基础):
    def __init__(self, 变量名: str) -> None:
        self.变量名 = 变量名


def c结构体():
    def 装饰函数(fn: Callable):
        定义 = fn()
        with c_结构体域(fn.__name__):
            for 字段名, (类型, 默认值) in 定义.items():
                类型(默认值, 变量名=字段名, 使用等号赋值=True)

        class 结构体类(c类型基础):
            类型名 = fn.__name__
            是结构体类 = True
        return 结构体类
    return 装饰函数


def 根据signature构建并调用函数(
        fn: Callable,
        self_=None,
        前缀: Union[None, str, List[str]] = None):
    sig = inspect.signature(fn)
    with c函数域(fn.__name__, sig.parameters,
               sig.return_annotation, 前缀) as f:
        参数列表 = []

        for 参数名, 参数 in sig.parameters.items():
            class Temp(c类型基础):
                类型名 = 参数.annotation.类型名
                是结构体类 = 参数.annotation.是结构体类

                def __init__(self):
                    self.类型 = Temp.类型名
                    self.变量名 = 参数名

            参数列表.append(Temp())
        ret = fn(*参数列表)
        if ret is not None:
            f.返回(ret)
    return f


def 调用函数域(fn: c函数域, *args):
    参数字符串 = ', '.join([str(arg) for arg in args])
    ID = c类型基础.生成ID()
    if fn.返回类型 == 'void':
        输出(f'{fn.函数名} ({参数字符串});\n')
        return 已存在变量('')
    else:
        输出(f'auto {ID} = {fn.函数名} ({参数字符串});\n')
        return 已存在变量(ID)


def c函数(前缀: Union[None, str, List[str]] = None):
    class 装饰类:
        def __init__(self, fn: Callable) -> None:
            self.函数 = 根据signature构建并调用函数(
                fn, None, 前缀)
            self.函数名 = fn.__name__

        def __call__(self, *args: Any) -> Any:
            return 调用函数域(self.函数, *args)

    return 装饰类


def c数组(类型, 长度: int):
    class c_数组类型(c类型基础):
        类型名 = f'{类型.类型名}*'
        数组长度 = 长度

        def 输出定义(self):
            if self.使用等号赋值:
                输出(f'{类型.类型名} {self}[{长度}] = {self.初始化字符串};\n')
            else:
                输出(f'{类型.类型名} {self}[{长度}];\n')

        def __getitem__(self, key):
            if key < 0 or key >= 长度:
                raise Exception(f'key = {key}。 但是key应该在[0, {长度})之间。')
            return super().__getitem__(key)

        def __setitem__(self, key, value):
            if key < 0 or key >= 长度:
                raise Exception(f'key = {key}。 但是key应该在[0, {长度})之间。')
            return super().__setitem__(key, value)

    return c_数组类型()
